/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__exportStar(__webpack_require__(/*! ./services */ "./src/services/index.ts"), exports);
__exportStar(__webpack_require__(/*! ./interfaces */ "./src/interfaces/index.ts"), exports);
const module_1 = __webpack_require__(/*! ./module */ "./src/module.ts");
const server_core_1 = __webpack_require__(/*! @common-stack/server-core */ "@common-stack/server-core");
exports["default"] = new server_core_1.Feature(module_1.default);


/***/ }),

/***/ "./src/interfaces/index.ts":
/*!*********************************!*\
  !*** ./src/interfaces/index.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.IExposePortRequest = void 0;
var core_1 = __webpack_require__(/*! @container-stack/core */ "@container-stack/core");
Object.defineProperty(exports, "IExposePortRequest", ({ enumerable: true, get: function () { return core_1.IKubectlExposePortRequest; } }));


/***/ }),

/***/ "./src/module.ts":
/*!***********************!*\
  !*** ./src/module.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const plugins_1 = __webpack_require__(/*! ./plugins */ "./src/plugins/index.ts");
const server_core_1 = __webpack_require__(/*! @common-stack/server-core */ "@common-stack/server-core");
exports["default"] = new server_core_1.Feature({
    addBrokerClientServiceClass: plugins_1.KubectlMoleculerService,
});


/***/ }),

/***/ "./src/plugins/index.ts":
/*!******************************!*\
  !*** ./src/plugins/index.ts ***!
  \******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__exportStar(__webpack_require__(/*! ./kubectl-moleculer-service */ "./src/plugins/kubectl-moleculer-service.ts"), exports);


/***/ }),

/***/ "./src/plugins/kubectl-moleculer-service.ts":
/*!**************************************************!*\
  !*** ./src/plugins/kubectl-moleculer-service.ts ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KubectlMoleculerService = void 0;
const moleculer_1 = __webpack_require__(/*! moleculer */ "moleculer");
const services_1 = __webpack_require__(/*! ../services */ "./src/services/index.ts");
const core_1 = __webpack_require__(/*! @container-stack/core */ "@container-stack/core");
class KubectlMoleculerService extends moleculer_1.Service {
    constructor(broker, _a) {
        var { container } = _a, settings = __rest(_a, ["container"]);
        super(broker);
        const topic = core_1.IMoleculerServiceName.KubectlService;
        this.kubectl = new services_1.KubectlApi();
        this.parseServiceSchema({
            name: topic,
            actions: {
                [core_1.IKubectlServiceAction.exposePort]: {
                    handler: async (ctx) => {
                        return await this.kubectl.exposePort(ctx.params.exposePortRequest);
                    },
                },
            },
        });
    }
}
exports.KubectlMoleculerService = KubectlMoleculerService;


/***/ }),

/***/ "./src/services/index.ts":
/*!*******************************!*\
  !*** ./src/services/index.ts ***!
  \*******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__exportStar(__webpack_require__(/*! ./kubectl */ "./src/services/kubectl.ts"), exports);


/***/ }),

/***/ "./src/services/kubectl.ts":
/*!*********************************!*\
  !*** ./src/services/kubectl.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KubectlApi = void 0;
const k8s = __webpack_require__(/*! @kubernetes/client-node */ "@kubernetes/client-node");
const kube = k8s.Config.defaultClient();
class KubectlApi {
    async exposePort(exposePortRequest) {
        let pod;
        let service = new k8s.V1Service();
        let port = new k8s.V1ServicePort();
        let exposed;
        kube.readNamespacedPod(exposePortRequest.podName, exposePortRequest.nameSpace).then(result => {
            pod = result.body;
            port.port = exposePortRequest.port;
            port.targetPort = exposePortRequest.targetPort;
            port.protocol = exposePortRequest.protocol;
            service.metadata = new k8s.V1ObjectMeta();
            service.metadata.name = exposePortRequest.name;
            service.metadata.namespace = exposePortRequest.nameSpace;
            service.spec = new k8s.V1ServiceSpec();
            service.spec.type = 'LoadBalancer';
            service.spec.ports = [port];
            service.spec.selector = pod.metadata.labels;
            kube.createNamespacedService(exposePortRequest.nameSpace, service).catch(err => { console.error(err); });
        });
    }
}
exports.KubectlApi = KubectlApi;


/***/ }),

/***/ "@common-stack/server-core":
/*!********************************************!*\
  !*** external "@common-stack/server-core" ***!
  \********************************************/
/***/ ((module) => {

module.exports = require("@common-stack/server-core");

/***/ }),

/***/ "@container-stack/core":
/*!****************************************!*\
  !*** external "@container-stack/core" ***!
  \****************************************/
/***/ ((module) => {

module.exports = require("@container-stack/core");

/***/ }),

/***/ "@kubernetes/client-node":
/*!******************************************!*\
  !*** external "@kubernetes/client-node" ***!
  \******************************************/
/***/ ((module) => {

module.exports = require("@kubernetes/client-node");

/***/ }),

/***/ "moleculer":
/*!****************************!*\
  !*** external "moleculer" ***!
  \****************************/
/***/ ((module) => {

module.exports = require("moleculer");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./src/index.ts");
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;
//# sourceMappingURL=index.js.map